﻿using DynamicData.Binding;
using System.ComponentModel.DataAnnotations;
using ReactiveUI;

namespace ComponentOneBlazorIssue.Data;

public class WeatherForecast : ReactiveObject
{
    private string _codeA = "";    
    public string CodeA
    {
        get => _codeA;
        set => this.RaiseAndSetIfChanged(ref _codeA, value);
    }

    private string _codeB = "";
    public string CodeB
    {
        get => _codeB;
        set => this.RaiseAndSetIfChanged(ref _codeB, value);
    }    

    public DateOnly Date { get; set; }

    public int TemperatureC { get; set; }

    public int TemperatureF => 32 + (int)(TemperatureC / 0.5556);

    public string? Summary { get; set; }

    public bool IsValid { get; set; } = true;

    public WeatherForecast()
    {
        //Validation.
        this.WhenAnyPropertyChanged()
        .Subscribe(s =>
        {
            //Validation.
            Validate();
        });
    }

    public void Validate()
    {
        if (string.IsNullOrEmpty(CodeA) || string.IsNullOrEmpty(CodeB))
        {
            IsValid = false;
        }
        else
        {
            IsValid = true;
        }
    }
}

