﻿using System;
using C1.Blazor.Grid;
using ComponentOneBlazorIssue.Controls;
using ComponentOneBlazorIssue.Data;
using Microsoft.AspNetCore.Components;

namespace ComponentOneBlazorIssue.Pages
{
	public partial class FetchData
	{
        private FlexGrid _grid = null!;
        private GridCellFactory _customGridCellFactory = null!;

        private List<WeatherForecast> _forecasts = new List<WeatherForecast>();

        [Inject]
        public ILogger<FetchData> Logger { get; set; } = null!;

        protected override void OnInitialized()
        {
            _customGridCellFactory = new CustomGridCellFactory(Logger);
        }

        protected override async Task OnInitializedAsync()
        {
            _forecasts = await ForecastService.GetForecastAsync(DateOnly.FromDateTime(DateTime.Now));
        }
    }
}

